unit aptdatreader_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,strutils,
  ExtCtrls, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    blue_bar2: TLabel;
    Complete_Panel1: TPanel;
    app_heading: TLabel;
    Image1: TImage;
    Memo1: TMemo;
    selected_file: TEdit;
    green_bar1: TLabel;
    btnLetsGo: TButton;
    edtcountry: TEdit;
    edtalt: TEdit;
    edtlevel: TEdit;
    edtflatten: TEdit;
    edtdriveleft: TEdit;
    edtauthority: TEdit;
    edtlocalcode: TEdit;
    edtcity: TEdit;
    edtlat: TEdit;
    edtlong: TEdit;
    edtfaa: TEdit;
    edtiata: TEdit;
    edticao: TEdit;
    edtregion: TEdit;
    edtstate: TEdit;
    green_bar2: TLabel;
    lblhowmanyacao: TLabel;
    Lbxicao: TListBox;
    Grids_Panel: TPanel;
    OpenDialog1: TOpenDialog;
    Grid_1300: TStringGrid;
    Grid_1301: TStringGrid;
    white_bar1: TLabel;
    working_label: TLabel;
    lblicai: TLabel;
    lblregion: TLabel;
    lblstate: TLabel;
    lblalt: TLabel;
    lbllevel: TLabel;
    lblflatten: TLabel;
    lbldriveleft: TLabel;
    lblauthority: TLabel;
    lbllocalcode: TLabel;
    red_bar1: TLabel;
    red_bar2: TLabel;
    lbl_airport_details: TLabel;
    lblcountry: TLabel;
    lblcity: TLabel;
    lbllat: TLabel;
    lbllong: TLabel;
    lblfaa: TLabel;
    lbliata: TLabel;
    Airport_Panel: TPanel;
    blue_bar1: TLabel;
    white_bar2: TLabel;
    working_label1: TLabel;
    working_label2: TLabel;
    procedure btnLetsGoClick(Sender: TObject);
    procedure Grid_1300SelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
    procedure Grid_1301EditingDone(Sender: TObject);
    procedure Grid_1301SelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
    procedure selected_fileClick(Sender: TObject);
    procedure LbxicaoClick(Sender: TObject);
    procedure Grid_1300EditingDone(Sender: TObject);
    procedure Grid_1300PrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private

  public
    Procedure Update_Working_Indicator(Const Astring:String);
    procedure populate_airport_data(L:longint);
    procedure Locate_And_Display_By_Country_City(fcountry,fcity,ficao:ansistring);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }



Type
  TAirPortLineData=Record
                     FileLine:LongInt;
                     Data:AnsiString;
                   end;
  TAirPortRquiredData=Record
                     ICAO:AnsiString;
                     FileLine:LongInt;
                     Data:AnsiString;
                   end;

  TAirports=record
               City,Country,lat,lon,faa,iata,icao,region,state,alt,level,flatten,driveleft,localcode,localauthority:TAirPortLineData;
             end;

Var Data_Changed:Array of Byte;
    Max_Possible:LongInt=8000000;
    Max_Airports:LongInt=40000;
    Total_Lines_In_FIle,AIrPort_Count:Integer;
    Airports:Array of TAirports;
    Analyzing_Data:Boolean=false;
    Total_Countries:longint;
    ProgressUpDn:Boolean=true;
    working_counter:integer=0;
    FiledataStarts:longint=-1;
    allow_duplicates:boolean=true;
    icao_Data:Array of UniCodeString;
    icao_data_count:longint;
    data_1300:array of TAirPortRquiredData;
    data_1300_count:Longint;
    data_1301:Array of TAirPortRquiredData;
    data_1301_count:Longint;
    GridSelectColor:tcolor=clBlue;
    old_grid1301:ansistring='';
    old_grid1300:ansistring='';

Function Extract_Just_The_Info(S,F:String):String;
var i:integer;
Begin
  Result:='';
  s:=trimright(s);
  if S<>'' then
  Begin
    if leftstr(s,length(f))<>f then showmessage(S);
    result:=copy(s,length(f)+1,length(s));
  end;
end;

Function ExistsInListBox(Const LB:TListBox;Var f:string):Boolean;
var loop:integer;
begin
  Result:=False;
  if allow_duplicates then exit;
  for loop:=0 to lb.Items.Count-1 do
  begin
    if lb.Items.Strings[loop]=f then
    begin
      result:=true;
      break;
    end;
  end;
end;

Procedure TForm1.Update_Working_Indicator(Const Astring:String);
Begin
  if AString='Remove' then
  begin
    red_bar1.Visible:=False;
    red_bar2.Visible:=False;
    Blue_bar1.Visible:=False;
    blue_bar2.Visible:=False;
    green_bar1.Visible:=False;
    green_bar2.Visible:=False;
    white_bar1.Visible:=False;
    white_bar2.Visible:=False;
    working_label.Visible:=False;
    working_label1.Visible:=False;
    working_label2.Visible:=False;
    app_heading.Visible:=True;
    exit;
  end;
  working_label.Caption:=aString;

  if ProgressUpDn then
  begin
    app_heading.Visible:=False;
    working_label.Visible:=true;
    working_label1.Visible:=true;
    working_label2.Visible:=true;
    red_bar1.Visible:=working_counter>0;
    red_bar2.Visible:=working_counter>0;
    blue_bar1.Visible:=working_counter>1;
    blue_bar2.Visible:=working_counter>1;
    green_bar1.Visible:=working_counter>2;
    green_bar2.Visible:=working_counter>2;
    white_bar1.Visible:=working_counter>3;
    white_bar2.Visible:=working_counter>3;
    inc(working_counter);
    if working_counter>=5 then working_counter:=0;
  end
  else
  begin
    red_bar1.Visible:=working_counter>3;
    red_bar2.Visible:=working_counter>3;
    blue_bar1.Visible:=working_counter>2;
    blue_bar2.Visible:=working_counter>2;
    green_bar1.Visible:=working_counter>1;
    green_bar2.Visible:=working_counter>1;
    white_bar1.Visible:=working_counter>0;
    white_bar2.Visible:=working_counter>0;
    dec(working_counter);
    if working_counter<0 then working_counter:=5;
    working_label.Visible:=true;
    working_label1.Visible:=false;
    working_label2.Visible:=false;
    app_heading.Visible:=False;
  end;
  application.ProcessMessages;
end;

procedure TForm1.btnLetsGoClick(Sender: TObject);
VAR filen:textfile;
    filename:string='R:\AIRDATA\apt.dat';
    s,c,d:string;
    Adding_airport:boolean=false;
    AIrport_Line_Count:Integer=0;
    airport_detail_counter:integer=0;
    p,i,hm:integer;
    Building_Data:Array of unicodestring;
    ok:boolean;
begin
  If Analyzing_Data Then Exit;
  Analyzing_Data:=True;
  // Blank Data
  Grid_1300.SelectedColor:=GridSelectColor;
  Grid_1301.SelectedColor:=GridSelectColor;
  filename:=selected_file.Caption;

  Total_Countries:=0;
  AIrPort_Count:=0;
  data_1301_count:=0;
  data_1300_count:=0;
  icao_data_count:=0;
  Memo1.Clear;
  memo1.Lines.Add('Items Changed');
  SetLength(Data_Changed,Max_Possible);
  SetLength(AirPorts,Max_Airports);
  SetLength(icao_Data,Max_Possible);
  SetLength(data_1300,Max_Possible);
  SetLength(data_1301,Max_Possible);
  Total_Lines_In_FIle:=0;
  Assignfile(filen,filename);
  Reset(filen);
  working_label.Visible:=true;
  working_label1.Visible:=true;
  working_label2.Visible:=true;
  ProgressUpDn:=true;

  While Not Eof(Filen) do
  begin
    ReadLn(Filen,S);
    if (Total_Lines_In_FIle mod 100000)=0 then
    begin
      working_label1.Caption:=inttostr(Total_Lines_In_FIle);
      working_label2.Caption:=working_label1.Caption;
      Update_Working_Indicator('Read Data');
      application.ProcessMessages;
    end;
    If S.StartsWith('1300') then
    begin
      Data_1300[data_1300_count].icao:=Airports[AIrPort_Count-1].icao.Data;
      Data_1300[data_1300_count].FileLine:=Total_Lines_In_File;
      Data_1300[data_1300_count].Data:=copy(s,6,length(s));;
      inc(data_1300_count);
    end;
    If S.StartsWith('1301') then
    begin
      Data_1301[data_1301_count].icao:=Airports[AIrPort_Count-1].icao.Data;
      Data_1301[data_1301_count].FileLine:=Total_Lines_In_File;
      Data_1301[data_1301_count].Data:=copy(s,6,length(s));;
      inc(data_1301_count);
    end;
    if s.StartsWith('1302 city') then Adding_Airport:=True;
    If S.StartsWith('1302') then
    begin
      If Adding_AirPort then
      begin
        p:=pos(' ',s);
        c:=copy(s,p+1,length(s));
        c:=leftstr(c,pos(' ',c)-1);
        case c of
          'city'   :begin
                      Airports[AIrPort_Count].City.Data:=copy(s,11,length(s));
                      Airports[AIrPort_Count].City.FileLine:=Total_Lines_In_FIle;
                    end;
          'country':begin
                      Airports[AIrPort_Count].country.Data:=copy(s,14,length(s));;
                      Airports[AIrPort_Count].Country.FileLine:=Total_Lines_In_FIle;
                    end;
          'datum_lat':begin
                      Airports[AIrPort_Count].lat.Data:=copy(s,16,length(s));;
                      Airports[AIrPort_Count].lat.FileLine:=Total_Lines_In_FIle;
                    end;
          'datum_lon':begin
                      Airports[AIrPort_Count].lon.Data:=copy(s,16,length(s));;
                      Airports[AIrPort_Count].lon.FileLine:=Total_Lines_In_FIle;
                    end;
          'faa_code':begin
                      Airports[AIrPort_Count].faa.Data:=copy(s,15,length(s));;
                      Airports[AIrPort_Count].faa.FileLine:=Total_Lines_In_FIle;
                    end;
          'iata_code':begin
                      Airports[AIrPort_Count].iata.Data:=copy(s,16,length(s));;
                      Airports[AIrPort_Count].iata.FileLine:=Total_Lines_In_FIle;
                    end;

          'icao_code':begin
                      Airports[AIrPort_Count].icao.Data:=copy(s,16,length(s));;
                      Airports[AIrPort_Count].icao.FileLine:=Total_Lines_In_FIle;
                      if Airports[AIrPort_Count].icao.Data<>'' then
                      begin
                        icao_Data[icao_data_count]:=Airports[AIrPort_Count].icao.Data;
                        inc(icao_data_count);
                      end;
                    end;
          'region_code':begin
                      Airports[AIrPort_Count].region.Data:=copy(s,18,length(s));;
                      Airports[AIrPort_Count].region.FileLine:=Total_Lines_In_FIle;
                    end;
          'state':begin
                      Airports[AIrPort_Count].state.Data:=copy(s,12,length(s));;
                      Airports[AIrPort_Count].state.FileLine:=Total_Lines_In_FIle;
                    end;
          'transition_alt':begin
                      Airports[AIrPort_Count].alt.Data:=copy(s,21,length(s));;
                      Airports[AIrPort_Count].alt.FileLine:=Total_Lines_In_FIle;
                    end;
          'transition_level':begin
                      Airports[AIrPort_Count].level.Data:=copy(s,23,length(s));;
                      Airports[AIrPort_Count].level.FileLine:=Total_Lines_In_FIle;
                    end;
          'flatten':begin
                      Airports[AIrPort_Count].flatten.Data:=copy(s,14,length(s));;
                      Airports[AIrPort_Count].flatten.FileLine:=Total_Lines_In_FIle;
                    end;
          'drive_on_left':begin
                      Airports[AIrPort_Count].driveleft.Data:=copy(s,20,length(s));;
                      Airports[AIrPort_Count].driveleft.FileLine:=Total_Lines_In_FIle;
                    end;
          'local_authority':begin
                      Airports[AIrPort_Count].localauthority.Data:=copy(s,22,length(s));;
                      Airports[AIrPort_Count].localauthority.FileLine:=Total_Lines_In_FIle;
                    end;
          'local_code':begin
                      Airports[AIrPort_Count].localcode.Data:=copy(s,17,length(s));;
                      Airports[AIrPort_Count].localcode.FileLine:=Total_Lines_In_FIle;
                    end;
        else showmessage(inttostr(Total_Lines_In_FIle)+'  '+s);
        end;
      end;
    end
    Else
    Begin
      If Adding_AirPort then
      Begin
        Adding_Airport:=False;
        inc(AIrPort_Count);
      end;
    end;
    Inc(Total_Lines_In_FIle);
  end;
  ProgressUpDn:=false;
  CloseFile(filen);
  SetLength(Data_Changed,Total_Lines_In_FIle);
  for I:=0 to high(Data_Changed) do Data_Changed[I]:=0;
  SetLength(Airports,AIrPort_Count);
  hm:=0;
  setlength(Building_Data,max_possible);
  lbxicao.Clear;
  lbxicao.sorted:=false;
  for I:=0 to icao_data_count-1 do
  begin
    d:=icao_data[i];
    if (i mod 1000)=0 then Update_Working_Indicator('Building');
    ok:=allow_duplicates;
    if allow_duplicates=false then ok:= matchstr(d,icao_data)=false;
    if d='' then ok:=false;
    if ok then
    begin
      building_data[hm]:=d;
      lbxicao.Items.Add(d);
      inc(hm);
    end;
  end;
  setlength(building_data,hm-1);
  Update_Working_Indicator('Sorting');
  lbxicao.Sorted:=true;
  lbxicao.Enabled:=lbxicao.Count>0;
  lblhowmanyacao.caption:=inttostr(lbxicao.Count);
  Update_Working_Indicator('Remove');
  Analyzing_Data:=False;
end;


procedure TForm1.Grid_1300SelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  old_grid1300:=Grid_1300.Cells[1,Grid_1300.Row];
end;

procedure TForm1.Grid_1301EditingDone(Sender: TObject);
var L:LongInt;
    s:string;
begin
  s:=Grid_1301.Cells[0,Grid_1300.Row];
  s:=copy(s,2,length(s)-2);
  L:=strtointdef(S,-1);
  if old_grid1301=Grid_1301.Cells[1,Grid_1301.Row] then exit;
  if l>=0 then
  Begin
    Data_Changed[l]:=1;
    Memo1.Lines.Add(Grid_1301.Cells[0,Grid_1301.Row]+' '+Grid_1301.Cells[1,Grid_1301.Row]);
  end;
end;


procedure TForm1.Grid_1301SelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  old_grid1301:=Grid_1301.Cells[1,Grid_1301.Row];
end;

procedure TForm1.selected_fileClick(Sender: TObject);
begin
  If OpenDialog1.Execute then selected_file.Caption:= OpenDialog1.FileName;
end;


procedure TForm1.populate_airport_data(L:longint);
begin
  edtcountry.Text:=AirPorts[L].Country.Data;
  edtcity.Text:=AirPorts[L].City.Data;
  edtlat.Text:=AirPorts[L].lat.Data;
  edtlong.Text:=AirPorts[L].lon.Data;
  edtfaa.Text:=AirPorts[L].faa.Data;
  edtiata.Text:=AirPorts[L].iata.Data;
  edticao.Text:=AirPorts[L].icao.Data;
  edtregion.Text:=AirPorts[L].region.Data;
  edtstate.Text:=AirPorts[L].state.Data;
  edtalt.Text:=AirPorts[L].alt.Data;
  edtlevel.Text:=AirPorts[L].level.Data;
  edtflatten.Text:=AirPorts[L].flatten.Data;
  edtdriveleft.Text:=AirPorts[L].driveleft.Data;
  edtauthority.Text:=AirPorts[L].localauthority.Data;
  edtlocalcode.Text:=AirPorts[L].localcode.Data;
  FiledataStarts:=AirPorts[L].Country.FileLine;
end;


procedure TForm1.Locate_And_Display_By_Country_City(fcountry,fcity,ficao:ansistring);
Var L,count1300,count1301:LongInt;
begin
  FiledataStarts:=-1;
  For L:=0 to AIrPort_Count-1 do
  begin
    if ((AirPorts[L].Country.Data=fcountry) and (AirPorts[L].City.Data=fcity) and (AirPorts[L].icao.Data=ficao)) then
    begin
      populate_airport_data(L);
      FiledataStarts:=AirPorts[L].Country.FileLine;
      break;
    end;
  end;
  if FiledataStarts<>-1 then
  begin
    lbl_airport_details.Caption:='Airport ( '+fcity+' - '+fcountry+' ) Details  - '+inttostr(FiledataStarts);
    count1300:=0;
    count1301:=0;
    Grid_1300.RowCount:=1000;
    application.ProcessMessages;
    for L:=0 to data_1300_count do
    begin
      if data_1300[L].ICAO=ficao then
      begin
        Grid_1300.Cells[0,count1300]:='['+inttostr(data_1300[L].FileLine)+']';
        Grid_1300.Cells[1,count1300]:='1300 '+data_1300[L].Data;
        inc(count1300);
      end;
    end;
    Grid_1300.RowCount:=count1300;
    Grid_1301.RowCount:=1000;
    application.ProcessMessages;
    for L:=0 to data_1301_count do
    begin
      if data_1301[L].ICAO=ficao then
      begin
        Grid_1301.Cells[0,count1301]:='['+inttostr(data_1301[L].FileLine)+']';
        Grid_1301.Cells[1,count1301]:='1301 '+data_1301[L].Data;
        inc(count1301);
      end;
    end;
    Grid_1301.RowCount:=count1301;
    application.ProcessMessages;
  end
  else
  begin
    lbl_airport_details.Caption:='Airport ( NONE ) Details  - '+inttostr(FiledataStarts);
    Grid_1300.RowCount:=0;
    application.ProcessMessages;
  end;
end;

procedure TForm1.LbxicaoClick(Sender: TObject);
var fcountry,fcity,d:string;
    L:LongInt;
begin
  d:=lbxicao.Items[lbxicao.ItemIndex];
  fcountry:='';
  fcity:='';
  For L:=0 to AIrPort_Count-1 do
  begin
    if AirPorts[L].icao.data=d then
    begin
      fcountry:=AirPorts[L].Country.Data;
      fcity:=AirPorts[L].City.data;
      break;
    end;
  end;
  Locate_And_Display_By_Country_City(fcountry,fcity,d);
end;


procedure TForm1.Grid_1300EditingDone(Sender: TObject);
var L:LongInt;
    s:string;
begin
  s:=Grid_1300.Cells[0,Grid_1300.Row];
  s:=copy(s,2,length(s)-2);
  if old_grid1300=Grid_1300.Cells[1,Grid_1300.Row] then exit;
  L:=strtointdef(S,-1);
  if l>=0 then
  Begin
    Data_Changed[l]:=1;
    Memo1.Lines.Add(Grid_1300.Cells[0,Grid_1300.Row]+' '+Grid_1300.Cells[1,Grid_1300.Row]);
  end;
end;

procedure TForm1.Grid_1300PrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
begin
  if (gdSelected in aState) then
  begin
    tstringgrid(sender).Canvas.Brush.Color := clblue;
    if acol=1 then
    begin
      tstringgrid(sender).Editor.Color:=GridSelectColor;
      tstringgrid(sender).Editor.Font.Color:=clwhite;
    end;
  end
end;


end.


